//+------------------------------------------------------------------+
//|                                              sysDojiRev_v1.0.mq5 |
//|                                         Copyright 2019, NickBixy |
//|                           https://www.mql5.com/en/users/nickbixy |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, NickBixy"
#property link      "https://www.mql5.com/en/users/nickbixy"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_plots   2

#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrOrangeRed
#property indicator_width1  1

#property indicator_type2   DRAW_ARROW
#property indicator_color2  clrAqua
#property indicator_width2  1

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
input double percentage=.10;

input string info="https://docs.mql4.com/constants/objectconstants/wingdings";//Windings font symbols
input int arrowWinding=169;//Arrow Wingding Character

double BEARISH[];
double BULLISH[];

double         iMABuffer[];
int    handle;
int    bars_calculated=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   IndicatorSetString(INDICATOR_SHORTNAME,"sysDojiRev");

//Bearish Set up
   SetIndexBuffer(0,BEARISH,INDICATOR_DATA);
   PlotIndexSetString(0,PLOT_LABEL,"sysDojiRev Bearish");
   PlotIndexSetInteger(0,PLOT_ARROW,arrowWinding);
   PlotIndexSetInteger(0,PLOT_ARROW_SHIFT,-10);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);

//Bullish Set up
   SetIndexBuffer(1,BULLISH,INDICATOR_DATA);
   PlotIndexSetString(1,PLOT_LABEL,"sysDojiRev Bullish");
   PlotIndexSetInteger(1,PLOT_ARROW,arrowWinding);
   PlotIndexSetInteger(1,PLOT_ARROW_SHIFT,10);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0.0);

   SetIndexBuffer(2,iMABuffer,INDICATOR_DATA);
   handle=iMA(_Symbol,PERIOD_CURRENT,10,0,MODE_SMA,PRICE_CLOSE);

   ArrayInitialize(BEARISH,0.0);
   ArrayInitialize(BULLISH,0.0);

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

   int copy=CopyBuffer(handle,2,0,rates_total,iMABuffer);


   int limit;
   int counted_bars=IndicatorCountedMQL4(prev_calculated);
//---- check for possible errors
   if(counted_bars<0)
      return(-1);
//---- the last counted bar will be recounted

   if(counted_bars>0)
      counted_bars--;

   limit=Bars(_Symbol,PERIOD_CURRENT)-counted_bars;

   for(int i=0; i<limit; i++)
     {
      double fRangeHL=high[i+1]-low[i+1];
      double fRangeCo=MathAbs(close[i+1]-open[i+1]);

      double fRangeHLOne=high[i+2]-low[i+2];
      double fRangeCoOne=MathAbs(close[i+2]-open[i+2]);



      if(((fRangeCo<=(fRangeHL*percentage)) && (close[i]<low[i+1])
          && (low[i+1]>iMABuffer[i]) && (close[i]<open[i]))
         ||
         ((close[i]<low[i+2]) && !(close[i+1]<low[i+2])
          && (fRangeCoOne <= (fRangeHLOne * percentage)) && (close[i]<open[i])
          && (low[i+2] > iMABuffer[i]))
        )
        {
         BEARISH[i]=high[i];
         BULLISH[i]=0.0;
        }
      else
         if(((fRangeCo <= (fRangeHL * percentage)) && (close[i]>high[i+1])
             && (high[i+1]< iMABuffer[i]) && (close[i]>open[i]))
            ||
            ((close[i]>high[i+2]) && !(close[i+1]>high[i+2])
             && (fRangeCoOne<=(fRangeHLOne*percentage))
             && (high[i+2]<iMABuffer[i])))
           {
            BULLISH[i]=low[i];
            BEARISH[i]=0.0;
           }
         else
           {
            BULLISH[i]=0.0;
            BEARISH[i]=0.0;
           }
     }

   return(rates_total);
  }
//+------------------------------------------------------------------+
int IndicatorCountedMQL4(int prev_calculated)
  {
   if(prev_calculated>0)
      return(prev_calculated-1);
   if(prev_calculated==0)
      return(0);
   return(0);
  }
//+------------------------------------------------------------------+
